vox_model   = require 'vox/vox_model'
vox_texture = require 'vox/vox_texture'

flagFormat = [[
return {
	frames = %1.f,
	width  = %1.f,
	height = %1.f,
}
]]

console = ""

function love.filedropped(file)
    local name = file:getFilename()
    newModel(file)
end

function newModel(file)
	file:open("r")
		local model = vox_model.new(file:read())
	file:close()
	
	local folder = string.gsub(file:getFilename(), ".vox", "")
	folder = string.sub(folder, string.len(love.filesystem.getWorkingDirectory()) - 2)
	love.filesystem.createDirectory(folder)
	
	local texture = vox_texture.new(model)
	
	texture.canvas:newImageData():encode("png", folder.."/texture.png") -- Writes texture image
	
	flag = love.filesystem.newFile(folder.."/flags.lua")
	flag:open("w")
		flag:write(string.format(flagFormat, texture.canvas:getWidth() / texture.sizeX, texture.sizeX, texture.sizeY)) -- Writes model flags
	flag:close()
	
	console = console.."Done with "..folder.."\n"
end

function love.draw()
	love.graphics.print(console)
end